/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package applet;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author miniexot
 */
public class MapData {

    private String dir;
    private String name;
    private String ext;
    private List<int[]> tileMatrixData;
    private List<String> IDs;
    private double minX, maxX, minY, maxY;

    public MapData() {
        dir = "";
        name = "";
        ext = "";
        tileMatrixData = new ArrayList<>();
        IDs = new ArrayList<>();
        minX = Double.POSITIVE_INFINITY;
        minY = Double.POSITIVE_INFINITY;
        maxX = Double.NEGATIVE_INFINITY;
        maxY = Double.NEGATIVE_INFINITY;

    }

    public double getMinX() {
        return minX;
    }

    public void setMinX(double minX) {
        this.minX = minX;
    }

    public void findMinX() {
        for (int[] tileMatrix : tileMatrixData) {
            if (tileMatrix[0] < minX) {
                minX = tileMatrix[0];
            }
        }
    }

    public double getMaxX() {
        return maxX;
    }

    public void setMaxX(double maxX) {
        this.maxX = maxX;
    }

    public void findMaxY() {
        for (int[] tileMatrix : tileMatrixData) {
            if ((tileMatrix[1] + ((tileMatrix[3] * tileMatrix[7]) - ((tileMatrix[7] - 1) * tileMatrix[5]))) > maxY) {
                maxY = tileMatrix[1] + ((tileMatrix[3] * tileMatrix[7]) - ((tileMatrix[7] - 1) * tileMatrix[5]));
            }
        }
    }

    public double getMinY() {
        return minY;
    }

    public void setMinY(double minY) {
        this.minY = minY;
    }

    public void findMinY() {
        for (int[] tileMatrix : tileMatrixData) {
            if (tileMatrix[1] < minY) {
                minY = tileMatrix[1];
            }
        }
    }

    public double getMaxY() {
        return maxY;
    }

    public void setMaxY(double maxY) {
        this.maxY = maxY;
    }

    public void findMaxX() {
        for (int[] tileMatrix : tileMatrixData) {
            if ((tileMatrix[0] + ((tileMatrix[2] * tileMatrix[6]) - ((tileMatrix[6] - 1) * tileMatrix[4]))) > maxX) {
                maxX = tileMatrix[0] + ((tileMatrix[2] * tileMatrix[6]) - ((tileMatrix[6] - 1) * tileMatrix[4]));
            }
        }
    }

    public List<String> getIDs() {
        return IDs;
    }

    public String getDir() {
        return dir;
    }

    public void setDir(String dir) {
        this.dir = dir;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getExt() {
        return ext;
    }

    public void setExt(String ext) {
        this.ext = ext;
    }

    public List<int[]> getTileMatrixData() {
        return tileMatrixData;
    }

    public void setTileMatrixData(int index, int index2, int data) {
        this.tileMatrixData.get(index)[index2] = data;
    }

}
