/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package applet;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BorderFactory;
import javax.swing.JPanel;

/**
 *
 * @author miniexot
 */
class Mapa extends JPanel {

    BufferedImage image;
    private int x = 0;
    private int y = 0;
    private int x1 = 0;
    private int y1 = 0;
    private int x3 = 0;
    private int y3 = 0;
    private int xSpodni = 0;
    private int ySpodni = 0;
    private Projection projekceMapy;
    private List<MapData> mapList;

    public Mapa(Projection projekceMapy, List mapList) {
        setBorder(BorderFactory.createLineBorder(Color.black));
        this.projekceMapy = projekceMapy;
        this.mapList = mapList;

        addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                //moveIt(e.getX(), e.getY());
                x1 = e.getX();
                y1 = e.getY();
                x3 = e.getX();
                y3 = e.getY();
            }
            
            public void mouseReleased(MouseEvent e) {
                moveIt(e.getX(), e.getY());
            }
        });

        addMouseMotionListener(new MouseAdapter() {
            public void mouseDragged(MouseEvent e) {
                dragIt(e.getX(), e.getY());
            }

        });
    }

    private void moveIt(int x2, int y2) {

        if ((x != x2) || (y != y2)) {
            /* repaint();
             x = x + (x2 - x1);
             y = y + (y2 - y1);*/
            projekceMapy.ChangeProjection(projekceMapy.getCenterX() - projekceMapy.GetModelLength(x2 - x3),
                    projekceMapy.getCenterY() + projekceMapy.GetModelLength(y2 - y3), projekceMapy.getRealScale());
            projekceMapy.Review(mapList.get(1), this);

            Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "DRAG: " + x3 + ";" + y3 + " -> " + x2 + ";" + y2);

            //x1 = x2;
           // y1 = y2;

            //repaint();
        }
    }
    
    private void dragIt(int x2, int y2) {

        if ((x != x2) || (y != y2)) {
             repaint();
             x = x + (x2 - x1);
             y = y + (y2 - y1);

            x1 = x2;
            y1 = y2;

            repaint();
        }
    }
    /*
     public Dimension getPreferredSize() {
     return new Dimension(1080, 530);
     }
     */

    public void paintCtverecek(BufferedImage img, int x1, int y1) {
        image = img;
        x = x1;
        y = y1;
        repaint();

    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);

        if (image != null) {
            g.drawImage(image, x, y, this);
        }
    }
}
